/**
 * Created by GamerSky-1014 on 2017/11/30 0030.
 */
var kGameShareCard_MinTop = 60.0;
var kGameShareCard_MaxBottom = 90.0;

function gameShareCard_updateLayout() {
    var window = $("window");
    var windowWidth = parseFloat(screen.width);
    var windowHeight = parseFloat(screen.height);

    var cardBox = $("#cardBox");
    var cardBoxLeft = 20;
    var cardBoxWidth = windowWidth - cardBoxLeft * 2;
    var cardBoxInnerRight = cardBoxWidth - 22;
    cardBox.style.left = cardBoxLeft + "px";
    cardBox.style.width = cardBoxWidth + "px";

    var cardBox_GameNameBox = $("#cardBox_GameNameBox");
    var cardBox_ScoreBox = $("#cardBox_ScoreBox");
    var cardBox_ScoreBoxWidth = cardBox_ScoreBox.offsetWidth;
    var cardBox_ScoreBoxLeft = (cardBoxInnerRight - cardBox_ScoreBoxWidth) + "px"; {
        cardBox_ScoreBox.style.left = cardBox_ScoreBoxLeft;
    }

    cardBox_GameNameBox.style.width = (cardBoxWidth -
            22.0 * 3.0 -
            cardBox_ScoreBoxWidth) +
        "px";

    cardBox_ScoreBox.style.left = (cardBoxWidth -
            22.0 -
            cardBox_ScoreBoxWidth) +
        "px";
	/*
    var cardBox_UserName = $("#cardBox_UserName");
    cardBox_UserName.style.width = (cardBoxInnerRight -
            cardBox_UserName.offsetLeft) +
        "px";
    */
    var cardBox_UserInfo = $("#cardBox_UserInfo");
    cardBox_UserInfo.style.width = (cardBoxInnerRight -
            cardBox_UserInfo.offsetLeft) +
        "px";

    var cardBox_UserScoreStarWidth = 0;
    if ($("#cardBox_UserScoreStar").style.display != "none")
    {
        cardBox_UserScoreStarWidth = 68;
    }
    $("#cardBox_UserPlayState").style.maxWidth
     = (windowWidth - 134 - cardBox_UserScoreStarWidth) + "px";

    var cardBox_CommentContentBox = $("#cardBox_CommentContentBox");
    cardBox_CommentContentBox.style.width = (cardBoxInnerRight -
            cardBox_CommentContentBox.offsetLeft) +
        "px";

    var cardBox_QRCode = $("#cardBox_QRCode");
    var cardBox_QRCodeTop = cardBox_CommentContentBox.offsetTop +
        cardBox_CommentContentBox.offsetHeight +
        15;
    cardBox_QRCode.style.top = cardBox_QRCodeTop +
        "px";

    var cardBox_QRCodeDescription = $("#cardBox_QRCodeDescription");
    cardBox_QRCodeDescription.style.top = (cardBox_QRCodeTop +
            2) +
        "px";

    var cardBoxHeight = cardBox_QRCodeTop +
        cardBox_QRCode.offsetHeight +
        22;
    var cardBoxTop = (windowHeight -
            cardBoxHeight) /
        2;
    if (cardBoxTop < kGameShareCard_MinTop) {
        cardBoxTop = kGameShareCard_MinTop;
    } {
        cardBox.style.top = cardBoxTop + "px";
        cardBox.style.height = cardBoxHeight + "px";
    }
    var cardBoxBottom = cardBoxTop +
        cardBoxHeight;

    var bottomGamerSkyLogo = $("#bottomGamerSkyLogo");
    var bottomGamerSkyLogoLeft = (windowWidth -
            bottomGamerSkyLogo.offsetWidth) /
        2;
    var bottomGamerSkyLogoTop = cardBoxBottom + 28; {
        bottomGamerSkyLogo.style.left = bottomGamerSkyLogoLeft +
            "px";
        bottomGamerSkyLogo.style.top = bottomGamerSkyLogoTop +
            "px";
    }

	// !!!
	var cardBox_ContentBackground = $("#cardBox_ContentBackground");
	cardBox_ContentBackground.style.height
	= (cardBoxHeight
	   - parseFloat(cardBox_ContentBackground.offsetTop))
	+ "px";
	// !!!
	
    var blurBackgroundBox = $("#blurBackgroundBox");
    var blurBackgroundBoxWidth = blurBackgroundBox.offsetWidth;
    var blurBackgroundBoxHeight
	= cardBoxBottom
	+ kGameShareCard_MaxBottom;
    if (blurBackgroundBoxHeight < windowHeight) {
        blurBackgroundBoxHeight = windowHeight;
    }
    blurBackgroundBox.style.height = blurBackgroundBoxHeight + "px";

    var blurBackground = $("#blurBackground");
    var blurBackgroundWidth = blurBackgroundBoxWidth * 1.5;
    var blurBackgroundHeight = blurBackgroundBoxHeight * 1.5;
    blurBackground.style.left = (blurBackgroundBoxWidth - blurBackgroundWidth) / 2.0 + "px";
    blurBackground.style.top = (blurBackgroundBoxHeight - blurBackgroundHeight) / 2.0 + "px";
    blurBackground.style.width = blurBackgroundWidth + "px";
    blurBackground.style.height = blurBackgroundHeight + "px";
    
    $("#fullMask").style.height = blurBackgroundBox.style.height;
}

function gameShareCard_didBodyLoad() {
    gameShareCard_updateLayout();

    $("window").onresize = function() {
        gameShareCard_updateLayout();
    };
}

// gsAppUpdateGameInfo({"coverImageURL":"TestResource/奥德赛-封面图.jpg", "backgroundImageURL":"", "name":"超级马里奥：奥德赛","englishName":"Super Mario Odyssey","score":10,"scoreUsersCount":99999,"userHeadImageURL":"TestResource/奥德赛-封面图.jpg","userName":"马里奥","userPlayState":"在SWITCH平台玩过","userScore":9,"userComment":"我就是为了奥德赛买的SWITCH，顺便入了一个荒野之息。老任的游戏真的很耐玩，随便一个小小的场景，塞满了好多隐藏元素，对于有收集强迫症的玩家来说，想要吃透还真要花一些时间，但这段收集的时间你并不会觉得无聊。"});
function gsAppUpdateGameInfo(gameInfo) {
    if (gameInfo == null) {
        return;
    }
    //
    try {
        var gameCoverImageInStyle = "url('" + gameInfo.coverImageURL + "')";

		if (gameInfo.backgroundImageURL != undefined
			&& gameInfo.backgroundImageURL != null
			&& gameInfo.backgroundImageURL.length>0)
		{
			$("#blurBackground").style.backgroundImage = "url('" + gameInfo.backgroundImageURL + "')";
		}
		else
		{
			$("#blurBackground").style.backgroundImage = gameCoverImageInStyle;
			$("#blurBackground").style.filter = "blur(50px)";
		}
		
        var cardBox_HeadImage = $("#cardBox_HeadImage");
        cardBox_HeadImage.style.backgroundImage = gameCoverImageInStyle;
        var cardBax_HeadImageResourceHeight = cardBox_HeadImage.offsetWidth * 814 / 500;
        cardBox_HeadImage.style.backgroundPositionY = (cardBox_HeadImage.offsetHeight / 2.0 -
            cardBax_HeadImageResourceHeight * 0.25) + "px";

        $("#cardBox_GameName").innerText = gameInfo.name;
        $("#cardBox_GameEnglishName").innerText = gameInfo.englishName;

        if (!gameInfo.marked)
        {
            var cardBox_GameScore = $("#cardBox_GameScore");
            cardBox_GameScore.innerText = gameInfo.wantUsersCount + "人";
            cardBox_GameScore.style.fontSize = "25px";
            $("#cardBox_GameScoreStar").style.display = "none";
            var cardBox_GameScoreUsersCount = $("#cardBox_GameScoreUsersCount");
            cardBox_GameScoreUsersCount.style.top = "62px";
            cardBox_GameScoreUsersCount.innerText = "期待";
        }
        else
        {
            var cardBox_GameScore = $("#cardBox_GameScore");
            cardBox_GameScore.innerText = gameInfo.score;
            cardBox_GameScore.style.fontSize = "30px";
            var cardBox_GameScoreStar = $("#cardBox_GameScoreStar");
            cardBox_GameScoreStar.style.display = "block";
            cardBox_GameScoreStar.getElementsByClassName("Star")[0].style.width = (100 * gameInfo.score / 10) + "%";
            var cardBox_GameScoreUsersCount = $("#cardBox_GameScoreUsersCount");
            cardBox_GameScoreUsersCount.style.top = "72px";
            cardBox_GameScoreUsersCount.innerText = gameInfo.scoreUsersCount + "人";
        }
		
		var userHeadImageURL = gameInfo.userHeadImageURL;
		if (!userHeadImageURL
			|| userHeadImageURL.length < 1)
		{
			userHeadImageURL = "common_User_AnonymousHead_72x72@2x.png";
		}
        $("#cardBox_UserHeadImage").style.backgroundImage = "url('" + userHeadImageURL + "')";
		
        if (gameInfo.userGroupId == 6
            || gameInfo.userGroupId == 9)
        {
            var cardBox_UserGroupIcon
            = $("#cardBox_UserGroupIcon");
            cardBox_UserGroupIcon.style.visibility
            = "visible";
            if (gameInfo.userGroupId == 6)
            {
                cardBox_UserGroupIcon.style.backgroundImage
                = "url(badge_AuthenticationV_Blue_20x20@2x.png)";
            }
            else
            {
                cardBox_UserGroupIcon.style.backgroundImage
                = "url(badge_AuthenticationV_Purple_20x20@2x.png)";
            }
        }
        $("#cardBox_UserName").innerHTML
         = gameInfo.userName
         + "<div id=\"cardBox_UserLevel\">" + gameInfo.userLevel + "</div>";
		var userPlayState = gameInfo.userPlayState;
		if (userPlayState == null
			|| userPlayState.length<1)
		{
            $("#cardBox_UserPlayState").innerText = "想玩";
			$("#cardBox_UserScoreStar").style.display = "none";
		}
		else
		{
			if (gameInfo.userPlayState=="玩过")
			{
				$("#cardBox_UserPlayState").innerText
				= gameInfo.userPlayState;
			}
			else
			{
				$("#cardBox_UserPlayState").innerText
                = "我在 "+gameInfo.userPlayState
				+ " 上玩过";
			}
            if (gameInfo.userScore>0)
            {
			    $("#cardBox_UserScoreStar").getElementsByClassName("Star")[0].style.width
                = (100 * gameInfo.userScore / 10) + "%";
            }
            else
            {
			    $("#cardBox_UserScoreStar").style.display = "none";
            }
        }

		var myComment = decodeURIComponent(gameInfo.userComment);
		{
			// 去除a标签和p标签，否则行数控制不准确
			myComment = myComment.replaceAll("<a", "<span");
			myComment = myComment.replaceAll("</a", "</span");
			myComment = myComment.replaceAll("<div>", "");
			myComment = myComment.replaceAll("</div>", "");
            myComment = myComment.replaceAll("<p>", "");
            myComment = myComment.replaceAll("</p>", "<br/>");
            myComment = myComment.replaceAll("\r", "<br/>");
            myComment = myComment.replaceAll("\n", "");
			myComment = "<p>" + myComment + "</p>";
		}
        $("#cardBox_CommentContent").innerHTML = myComment;

		var fullMask = $("#fullMask");
		if (fullMask.style.opacity==""
			|| parseFloat(style.opacity)>0.0)
		{
			setTimeout(function()
					   {
						   $("html").style.overflowY = "auto";
						   fullMask.style.opacity = 0.0;
						   fullMask.style.animation = "keyframes_Opacity1To0 0.3s ease-in";
					   },
					   100);
		}
    } catch (e) {}
    //
    gameShareCard_updateLayout();
}
